program SetAffinity;

{2014-Feb-12  First version}

{$APPTYPE CONSOLE}

uses
  Windows, SysUtils, TLHelp32;

  function FindProcessHandle (exe_name: string): integer;
  var
    snapshot: Longint;
    process: TProcessEntry32;
    more: boolean;
  begin
    Result := 0;
    snapshot := CreateToolHelp32SnapShot (TH32CS_SNAPPROCESS, 0);
    if SnapShot <> 0 then
      begin
      exe_name := UpperCase (exe_name);
      process.dwSize := SizeOf (process);
      more := Process32First (SnapShot, process);
      while more do
        begin
        if (Pos (exe_name, UpperCase (process.szExeFile)) <> 0) then
          begin
          Result := process.th32ProcessID;
          Break;
          end;
        more := Process32Next (snapshot, process);
        end;
      CloseHandle (snapshot);
      end;
  end;


const
  new_affinity_mask: Cardinal = 1;
  process_name = 'SmartDefrag.exe';
var
  process_ID: Cardinal;
  process_mask, system_mask: Cardinal;
  proc_handle: integer;
begin
  try
    process_ID := FindProcessHandle (process_name);
    if process_ID <> 0
    then
      begin
      WriteLn ('Process ' + process_name + ' ID is: ' + IntToStr (process_ID));
      proc_handle := OpenProcess(PROCESS_ALL_ACCESS, False, process_ID);
      GetProcessAffinityMask (proc_handle, process_mask, system_mask);
      WriteLn ('Before   process: ' + IntToHex (process_mask, 4) +
               ',  system: ' + IntToHex (system_mask, 4));
      SetProcessAffinityMask (proc_handle, new_affinity_mask);
      GetProcessAffinityMask (proc_handle, process_mask, system_mask);
      WriteLn ('After    process: ' + IntToHex (process_mask, 4) +
               ',  system: ' + IntToHex (system_mask, 4));
      end
    else
      WriteLn ('Could not find process: ' + process_name);
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
  Sleep (1500);
end.
